/**********************************************************************
 * Copyright (c) 2005-2009 David Carter <dcarter@arm4.org> and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * David Carter - Initial API and implementation
 **********************************************************************/

#include "config.h"
#include <cstdio>
#include <cstdarg>

#include "Arm4dbExceptions.h"

Arm4dbException::Arm4dbException ()
{}

Arm4dbException::Arm4dbException (const std::string &reason) :
	m_reason (reason)
{}

Arm4dbException::Arm4dbException (const Arm4dbException &e) :
	m_reason (e.m_reason)
{}

Arm4dbException::Arm4dbException (const char *format, ...)
{
	char buffer [4096]; // a largish buffer to contain any string
    va_list ap;

    va_start (ap, format);
	vsnprintf (buffer, sizeof (buffer), format, ap);
    va_end (ap);

	m_reason = buffer;
}

Arm4dbException::~Arm4dbException ()
{}

Arm4dbException &
Arm4dbException::operator= (const Arm4dbException &e)
{
	if (&e != this)
	{
		m_reason = e.m_reason;
	}

	return *this;
}


Arm4dbTestDaemonException::Arm4dbTestDaemonException (const char *format, ...)
{
	char buffer [4096]; // a largish buffer to contain any string
    va_list ap;

    va_start (ap, format);
	vsnprintf (buffer, sizeof (buffer), format, ap);
    va_end (ap);

	m_reason = buffer;
}

